init.d.ex 4.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163
  1. #!/bin/sh
  2. ### BEGIN INIT INFO
  3. # Provides: http-parser
  4. # Required-Start: $network $local_fs
  5. # Required-Stop:
  6. # Default-Start: 2 3 4 5
  7. # Default-Stop: 0 1 6
  8. # Short-Description: <Enter a short description of the software>
  9. # Description: <Enter a long description of the software>
  10. # <...>
  11. # <...>
  12. ### END INIT INFO
  13. # Author: Praveen Arimbrathodiyil <praveen@debian.org>
  14. # PATH should only include /usr/* if it runs after the mountnfs.sh script
  15. PATH=/sbin:/usr/sbin:/bin:/usr/bin
  16. DESC=http-parser # Introduce a short description here
  17. NAME=http-parser # Introduce the short server's name here
  18. DAEMON=/usr/sbin/http-parser # Introduce the server's location here
  19. DAEMON_ARGS="" # Arguments to run the daemon with
  20. PIDFILE=/var/run/$NAME.pid
  21. SCRIPTNAME=/etc/init.d/$NAME
  22. # Exit if the package is not installed
  23. [ -x $DAEMON ] || exit 0
  24. # Read configuration variable file if it is present
  25. [ -r /etc/default/$NAME ] && . /etc/default/$NAME
  26. # Load the VERBOSE setting and other rcS variables
  27. . /lib/init/vars.sh
  28. # Define LSB log_* functions.
  29. # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
  30. . /lib/lsb/init-functions
  31. #
  32. # Function that starts the daemon/service
  33. #
  34. do_start()
  35. {
  36. # Return
  37. # 0 if daemon has been started
  38. # 1 if daemon was already running
  39. # 2 if daemon could not be started
  40. start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
  41. || return 1
  42. start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
  43. $DAEMON_ARGS \
  44. || return 2
  45. # The above code will not work for interpreted scripts, use the next
  46. # six lines below instead (Ref: #643337, start-stop-daemon(8) )
  47. #start-stop-daemon --start --quiet --pidfile $PIDFILE --startas $DAEMON \
  48. # --name $NAME --test > /dev/null \
  49. # || return 1
  50. #start-stop-daemon --start --quiet --pidfile $PIDFILE --startas $DAEMON \
  51. # --name $NAME -- $DAEMON_ARGS \
  52. # || return 2
  53. # Add code here, if necessary, that waits for the process to be ready
  54. # to handle requests from services started subsequently which depend
  55. # on this one. As a last resort, sleep for some time.
  56. }
  57. #
  58. # Function that stops the daemon/service
  59. #
  60. do_stop()
  61. {
  62. # Return
  63. # 0 if daemon has been stopped
  64. # 1 if daemon was already stopped
  65. # 2 if daemon could not be stopped
  66. # other if a failure occurred
  67. start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
  68. RETVAL="$?"
  69. [ "$RETVAL" = 2 ] && return 2
  70. # Wait for children to finish too if this is a daemon that forks
  71. # and if the daemon is only ever run from this initscript.
  72. # If the above conditions are not satisfied then add some other code
  73. # that waits for the process to drop all resources that could be
  74. # needed by services started subsequently. A last resort is to
  75. # sleep for some time.
  76. start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
  77. [ "$?" = 2 ] && return 2
  78. # Many daemons don't delete their pidfiles when they exit.
  79. rm -f $PIDFILE
  80. return "$RETVAL"
  81. }
  82. #
  83. # Function that sends a SIGHUP to the daemon/service
  84. #
  85. do_reload() {
  86. #
  87. # If the daemon can reload its configuration without
  88. # restarting (for example, when it is sent a SIGHUP),
  89. # then implement that here.
  90. #
  91. start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
  92. return 0
  93. }
  94. case "$1" in
  95. start)
  96. [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME"
  97. do_start
  98. case "$?" in
  99. 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
  100. 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
  101. esac
  102. ;;
  103. stop)
  104. [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
  105. do_stop
  106. case "$?" in
  107. 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
  108. 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
  109. esac
  110. ;;
  111. status)
  112. status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
  113. ;;
  114. #reload|force-reload)
  115. #
  116. # If do_reload() is not implemented then leave this commented out
  117. # and leave 'force-reload' as an alias for 'restart'.
  118. #
  119. #log_daemon_msg "Reloading $DESC" "$NAME"
  120. #do_reload
  121. #log_end_msg $?
  122. #;;
  123. restart|force-reload)
  124. #
  125. # If the "reload" option is implemented then remove the
  126. # 'force-reload' alias
  127. #
  128. log_daemon_msg "Restarting $DESC" "$NAME"
  129. do_stop
  130. case "$?" in
  131. 0|1)
  132. do_start
  133. case "$?" in
  134. 0) log_end_msg 0 ;;
  135. 1) log_end_msg 1 ;; # Old process is still running
  136. *) log_end_msg 1 ;; # Failed to start
  137. esac
  138. ;;
  139. *)
  140. # Failed to stop
  141. log_end_msg 1
  142. ;;
  143. esac
  144. ;;
  145. *)
  146. #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
  147. echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
  148. exit 3
  149. ;;
  150. esac
  151. :